// Generated by 'peg2'
// https://pub.dev/packages/peg2

import 'package:peg2/grammar.dart';
import 'package:peg2/expressions.dart';

int _escape(int c) {
  switch (c) {
    case 110:
      return 0xA;
    case 114:
      return 0xD;
    case 116:
      return 0x9;
  }

  return c;
}

Expression _prefix(String prefix, Expression expression, String variable) {
  switch (prefix) {
    case '&':
      expression = AndPredicateExpression(expression);
      break;
    case '!':
      expression = NotPredicateExpression(expression);
      break;
  }

  expression.variable = variable;
  return expression;
}

Expression _suffix(String suffix, Expression expression) {
  switch (suffix) {
    case '?':
      return OptionalExpression(expression);
    case '*':
      return ZeroOrMoreExpression(expression);
    case '+':
      return OneOrMoreExpression(expression);
  }

  return expression;
}

class Peg2Parser {
  static const _eof = 0x110000;

  FormatException error;

  int _c;

  int _error;

  List<String> _expected;

  int _failure;

  List<int> _input;

  List<bool> _memoizable;

  List<List<_Memo>> _memos;

  var _mresult;

  int _pos;

  bool _predicate;

  dynamic _result;

  bool _success;

  String _text;

  List<int> _trackCid;

  List<int> _trackPos;

  dynamic parse(String text) {
    if (text == null) {
      throw ArgumentError.notNull('text');
    }
    _text = text;
    _input = _toRunes(text);
    _reset();
    final result = _parseGrammar(0, true);
    _buildError();
    _expected = null;
    _input = null;
    return result;
  }

  void _buildError() {
    if (_success) {
      error = null;
      return;
    }

    String escape(int c) {
      switch (c) {
        case 10:
          return r'\n';
        case 13:
          return r'\r';
        case 09:
          return r'\t';
        case _eof:
          return 'end of file';
      }
      return String.fromCharCode(c);
    }

    String getc(int position) {
      if (position < _text.length) {
        return "'${escape(_input[position])}'";
      }
      return 'end of file';
    }

    String report(String message, String source, int start) {
      if (start < 0 || start > source.length) {
        start = null;
      }

      final sb = StringBuffer();
      sb.write(message);
      var line = 0;
      var col = 0;
      var lineStart = 0;
      var started = false;
      if (start != null) {
        for (var i = 0; i < source.length; i++) {
          final c = source.codeUnitAt(i);
          if (!started) {
            started = true;
            lineStart = i;
            line++;
            col = 1;
          } else {
            col++;
          }
          if (c == 10) {
            started = false;
          }
          if (start == i) {
            break;
          }
        }
      }

      if (start == null) {
        sb.writeln('.');
      } else if (line == 0 || start == source.length) {
        sb.write(' (at offset ');
        sb.write(start);
        sb.writeln('):');
      } else {
        sb.write(' (at line ');
        sb.write(line);
        sb.write(', column ');
        sb.write(col);
        sb.writeln('):');
      }

      List<int> escape(int c) {
        switch (c) {
          case 9:
            return [92, 116];
          case 10:
            return [92, 110];
          case 13:
            return [92, 114];
          default:
            return [c];
        }
      }

      const max = 70;
      if (start != null) {
        final c1 = <int>[];
        final c2 = <int>[];
        final half = max ~/ 2;
        var cr = false;
        for (var i = start; i >= lineStart && c1.length < half; i--) {
          if (i == source.length) {
            c2.insert(0, 94);
          } else {
            final c = source.codeUnitAt(i);
            final escaped = escape(c);
            c1.insertAll(0, escaped);
            if (c == 10) {
              cr = true;
            }

            final r = i == start ? 94 : 32;
            for (var k = 0; k < escaped.length; k++) {
              c2.insert(0, r);
            }
          }
        }

        for (var i = start + 1;
            i < source.length && c1.length < max && !cr;
            i++) {
          final c = source.codeUnitAt(i);
          final escaped = escape(c);
          c1.addAll(escaped);
          if (c == 10) {
            break;
          }
        }

        final text1 = String.fromCharCodes(c1);
        final text2 = String.fromCharCodes(c2);
        sb.writeln(text1);
        sb.writeln(text2);
      }

      return sb.toString();
    }

    final temp = _expected.toList();
    temp.sort((e1, e2) => e1.compareTo(e2));
    final expected = temp.toSet();
    final hasMalformed = false;
    if (expected.isNotEmpty) {
      if (!hasMalformed) {
        final sb = StringBuffer();
        sb.write('Expected ');
        sb.write(expected.join(', '));
        sb.write(' but found ');
        sb.write(getc(_error));
        final title = sb.toString();
        final message = report(title, _text, _error);
        error = FormatException(message);
      } else {
        final reason = _error == _text.length ? 'Unterminated' : 'Malformed';
        final sb = StringBuffer();
        sb.write(reason);
        sb.write(' ');
        sb.write(expected.join(', '));
        final title = sb.toString();
        final message = report(title, _text, _error);
        error = FormatException(message);
      }
    } else {
      final sb = StringBuffer();
      sb.write('Unexpected character ');
      sb.write(getc(_error));
      final title = sb.toString();
      final message = report(title, _text, _error);
      error = FormatException(message);
    }
  }

  int _matchRanges(List<int> ranges) {
    int result;
    _success = false;
    for (var i = 0; i < ranges.length; i += 2) {
      if (ranges[i] <= _c) {
        if (ranges[i + 1] >= _c) {
          result = _c;
          _c = _input[_pos += _c <= 0xffff ? 1 : 2];
          _success = true;
          break;
        }
      } else {
        break;
      }
    }

    if (!_success) {
      _failure = _pos;
    }

    return result;
  }

  String _matchString(String text) {
    String result;
    final length = text.length;
    final rest = _text.length - _pos;
    final count = length > rest ? rest : length;
    var pos = _pos;
    var i = 0;
    for (; i < count; i++, pos++) {
      if (text.codeUnitAt(i) != _text.codeUnitAt(pos)) {
        break;
      }
    }

    if (i == length) {
      _c = _input[_pos += length];
      _success = true;
      result = text;
    } else {
      _success = false;
      _failure = _pos + i;
    }

    return result;
  }

  bool _memoized(int id, int cid) {
    final memos = _memos[_pos];
    if (memos != null) {
      for (var i = 0; i < memos.length; i++) {
        final memo = memos[i];
        if (memo.id == id) {
          _pos = memo.pos;
          _mresult = memo.result;
          _success = memo.success;
          _c = _input[_pos];
          return true;
        }
      }
    }

    if (_memoizable[cid] != null) {
      return false;
    }

    final lastCid = _trackCid[id];
    final lastPos = _trackPos[id];
    _trackCid[id] = cid;
    _trackPos[id] = _pos;
    if (lastCid == null) {
      return false;
    }

    if (lastPos == _pos) {
      if (lastCid != cid) {
        _memoizable[lastCid] = true;
        _memoizable[cid] = false;
      }
    }

    return false;
  }

  void _memoize(int id, int pos, result) {
    var memos = _memos[pos];
    if (memos == null) {
      memos = [];
      _memos[pos] = memos;
    }

    final memo = _Memo(
      id: id,
      pos: _pos,
      result: result,
      success: _success,
    );

    memos.add(memo);
  }

  void _reset() {
    _c = _input[0];
    _error = 0;
    _expected = [];
    _failure = -1;
    _memoizable = [];
    _memoizable.length = 444;
    _memos = [];
    _memos.length = _input.length + 1;
    _pos = 0;
    _predicate = false;
    _trackCid = [];
    _trackCid.length = 444;
    _trackPos = [];
    _trackPos.length = 444;
  }

  List<int> _toRunes(String source) {
    final length = source.length;
    final result = List<int>(length + 1);
    for (var pos = 0; pos < length;) {
      int c;
      final start = pos;
      final leading = source.codeUnitAt(pos++);
      if ((leading & 0xFC00) == 0xD800 && pos < length) {
        final trailing = source.codeUnitAt(pos);
        if ((trailing & 0xFC00) == 0xDC00) {
          c = 0x10000 + ((leading & 0x3FF) << 10) + (trailing & 0x3FF);
          pos++;
        } else {
          c = leading;
        }
      } else {
        c = leading;
      }

      result[start] = c;
    }

    result[length] = 0x110000;
    return result;
  }

  Grammar _parseGrammar(int $0, bool $1) {
    Grammar $2;
    final $4 = _c;
    final $5 = _pos;
    _parse_leading_spaces(3, false);
    _success = true;
    final $9 = _parse_globals(5, $1);
    _success = true;
    final $10 = _parse_members(7, $1);
    _success = true;
    List<ProductionRule> $11;
    if ($1) {
      $11 = [];
    }
    var $12 = false;
    for (;;) {
      final $13 = _parseDefinition(9, $1);
      if (!_success) {
        _success = $12;
        if (!_success) {
          $11 = null;
        }
        break;
      }
      if ($1) {
        $11.add($13);
      }
      $12 = true;
    }
    if (_success) {
      _parse_end_of_file(10, false);
      if (_success) {
        final g = $9;
        final m = $10;
        final d = $11;
        Grammar $$;
        $$ = Grammar(d, g, m);
        $2 = $$;
      }
    }
    if (!_success) {
      _c = $4;
      _pos = $5;
      if ($5 == _error) {
        _expected.addAll(const [
          '\'non terminal name\'',
          '\'terminal name\'',
          '\'sub terminal name\'',
          '\'library prefix\'',
          '\'type name\''
        ]);
      }
    }
    return $2;
  }

  ProductionRule _parseDefinition(int $0, bool $1) {
    ProductionRule $2;
    final $4 = _c;
    final $5 = _pos;
    for (;;) {
      $2 = _parseNonterminalDefinition(13, $1);
      if (_success) {
        break;
      } else {
        _c = $4;
        _pos = $5;
      }
      $2 = _parseTerminalDefinition(15, $1);
      if (_success) {
        break;
      } else {
        _c = $4;
        _pos = $5;
      }
      $2 = _parseSubterminalDefinition(17, $1);
      if (_success) {
      } else {
        _c = $4;
        _pos = $5;
      }
      break;
    }
    if (!_success) {
      if ($5 == _error) {
        _expected.addAll(const [
          '\'non terminal name\'',
          '\'terminal name\'',
          '\'sub terminal name\'',
          '\'library prefix\'',
          '\'type name\''
        ]);
      }
    }
    return $2;
  }

  ProductionRule _parseNonterminalDefinition(int $0, bool $1) {
    ProductionRule $2;
    final $4 = _c;
    final $5 = _pos;
    for (;;) {
      final $8 = _parseType(20, $1);
      if (_success) {
        final $9 = _parse_non_terminal_name(21, $1);
        if (_success) {
          _parse_$EqualSign(22, false);
          if (_success) {
            final $11 = _parseNonterminalExpression(23, $1);
            if (_success) {
              _parse_$Semicolon(24, false);
              if (_success) {
                final t = $8;
                final n = $9;
                final e = $11;
                ProductionRule $$;
                $$ = ProductionRule(n, ProductionRuleKind.nonterminal, e, t);
                $2 = $$;
              }
            }
          }
        }
      }
      if (_success) {
        break;
      } else {
        _c = $4;
        _pos = $5;
      }
      final $15 = _parse_non_terminal_name(26, $1);
      if (_success) {
        _parse_$EqualSign(27, false);
        if (_success) {
          final $17 = _parseNonterminalExpression(28, $1);
          if (_success) {
            _parse_$Semicolon(29, false);
            if (_success) {
              final n = $15;
              final e = $17;
              ProductionRule $$;
              $$ = ProductionRule(n, ProductionRuleKind.nonterminal, e, null);
              $2 = $$;
            }
          }
        }
      }
      if (_success) {
      } else {
        _c = $4;
        _pos = $5;
      }
      break;
    }
    if (!_success) {
      if ($5 == _error) {
        _expected.addAll(const [
          '\'non terminal name\'',
          '\'library prefix\'',
          '\'type name\''
        ]);
      }
    }
    return $2;
  }

  OrderedChoiceExpression _parseNonterminalExpression(int $0, bool $1) {
    OrderedChoiceExpression $2;
    final $4 = _c;
    final $5 = _pos;
    final $8 = _parseNonterminalSequence(32, $1);
    if (_success) {
      List<SequenceExpression> $9;
      if ($1) {
        $9 = [];
      }
      for (;;) {
        SequenceExpression $10;
        final $11 = _c;
        final $12 = _pos;
        _parse_$Slash(36, false);
        if (_success) {
          $10 = _parseNonterminalSequence(37, $1);
        }
        if (!_success) {
          _c = $11;
          _pos = $12;
          if ($12 == _error) {
            _expected.add('\'/\'');
          }
        }
        if (!_success) {
          break;
        }
        if ($1) {
          $9.add($10);
        }
      }
      _success = true;
      {
        final e = $8;
        final n = $9;
        OrderedChoiceExpression $$;
        $$ = OrderedChoiceExpression([e, ...n]);
        $2 = $$;
      }
    }
    if (!_success) {
      _c = $4;
      _pos = $5;
      if ($5 == _error) {
        _expected.addAll(
            const ['\'non terminal name\'', '\'terminal name\'', '\'(\'']);
      }
    }
    return $2;
  }

  SequenceExpression _parseNonterminalSequence(int $0, bool $1) {
    SequenceExpression $2;
    final $4 = _c;
    final $5 = _pos;
    List<Expression> $8;
    if ($1) {
      $8 = [];
    }
    var $9 = false;
    for (;;) {
      final $10 = _parseNonterminalPrefix(41, $1);
      if (!_success) {
        _success = $9;
        if (!_success) {
          $8 = null;
        }
        break;
      }
      if ($1) {
        $8.add($10);
      }
      $9 = true;
    }
    if (_success) {
      final $11 = _parse_action(43, $1);
      _success = true;
      {
        final e = $8;
        final a = $11;
        SequenceExpression $$;
        $$ = SequenceExpression(e, a);
        $2 = $$;
      }
    }
    if (!_success) {
      _c = $4;
      _pos = $5;
      if ($5 == _error) {
        _expected.addAll(
            const ['\'non terminal name\'', '\'terminal name\'', '\'(\'']);
      }
    }
    return $2;
  }

  Expression _parseNonterminalPrefix(int $0, bool $1) {
    Expression $2;
    final $4 = _c;
    final $5 = _pos;
    final $8 = _parse_semantic_value(47, $1);
    _success = true;
    String $9;
    final $10 = _c;
    final $11 = _pos;
    final $12 = _pos;
    for (;;) {
      $9 = _parse_$Ampersand(51, $1);
      if (_success) {
        break;
      } else {
        _c = $10;
        _pos = $11;
      }
      $9 = _parse_$ExclamationMark(53, $1);
      if (_success) {
      } else {
        _c = $10;
        _pos = $11;
      }
      break;
    }
    if (!_success) {
      if ($12 == _error) {
        _expected.addAll(const ['\'&\'', '\'!\'']);
      }
    }
    _success = true;
    final $19 = _parseNonterminalSuffix(54, $1);
    if (_success) {
      final s = $8;
      final p = $9;
      final e = $19;
      Expression $$;
      $$ = _prefix(p, e, s);
      $2 = $$;
    }
    if (!_success) {
      _c = $4;
      _pos = $5;
      if ($5 == _error) {
        _expected.addAll(
            const ['\'non terminal name\'', '\'terminal name\'', '\'(\'']);
      }
    }
    return $2;
  }

  Expression _parseNonterminalSuffix(int $0, bool $1) {
    Expression $2;
    final $4 = _c;
    final $5 = _pos;
    final $8 = _parseNonterminalPrimary(57, $1);
    if (_success) {
      String $9;
      final $10 = _c;
      final $11 = _pos;
      final $12 = _pos;
      for (;;) {
        $9 = _parse_$QuestionMark(61, $1);
        if (_success) {
          break;
        } else {
          _c = $10;
          _pos = $11;
        }
        $9 = _parse_$Asterisk(63, $1);
        if (_success) {
          break;
        } else {
          _c = $10;
          _pos = $11;
        }
        $9 = _parse_$PlusSign(65, $1);
        if (_success) {
        } else {
          _c = $10;
          _pos = $11;
        }
        break;
      }
      if (!_success) {
        if ($12 == _error) {
          _expected.addAll(const ['\'?\'', '\'*\'', '\'+\'']);
        }
      }
      _success = true;
      {
        final e = $8;
        final s = $9;
        Expression $$;
        $$ = _suffix(s, e);
        $2 = $$;
      }
    }
    if (!_success) {
      _c = $4;
      _pos = $5;
      if ($5 == _error) {
        _expected.addAll(
            const ['\'non terminal name\'', '\'terminal name\'', '\'(\'']);
      }
    }
    return $2;
  }

  Expression _parseNonterminalPrimary(int $0, bool $1) {
    Expression $2;
    final $4 = _c;
    final $5 = _pos;
    for (;;) {
      final $8 = _parse_non_terminal_name(68, $1);
      if (_success) {
        final n = $8;
        Expression $$;
        $$ = NonterminalExpression(n);
        $2 = $$;
      }
      if (_success) {
        break;
      } else {
        _c = $4;
        _pos = $5;
      }
      final $11 = _parse_terminal_name(70, $1);
      if (_success) {
        final n = $11;
        Expression $$;
        $$ = TerminalExpression(n);
        $2 = $$;
      }
      if (_success) {
        break;
      } else {
        _c = $4;
        _pos = $5;
      }
      _parse_$LeftParenthesis(72, false);
      if (_success) {
        $2 = _parseNonterminalExpression(73, $1);
        if (_success) {
          _parse_$RightParenthesis(74, false);
        }
      }
      if (_success) {
      } else {
        _c = $4;
        _pos = $5;
      }
      break;
    }
    if (!_success) {
      if ($5 == _error) {
        _expected.addAll(
            const ['\'non terminal name\'', '\'terminal name\'', '\'(\'']);
      }
    }
    return $2;
  }

  ProductionRule _parseTerminalDefinition(int $0, bool $1) {
    ProductionRule $2;
    final $4 = _c;
    final $5 = _pos;
    for (;;) {
      final $8 = _parseType(77, $1);
      if (_success) {
        final $9 = _parse_terminal_name(78, $1);
        if (_success) {
          _parse_$EqualSign(79, false);
          if (_success) {
            final $11 = _parseExpression(80, $1);
            if (_success) {
              _parse_$Semicolon(81, false);
              if (_success) {
                final t = $8;
                final n = $9;
                final e = $11;
                ProductionRule $$;
                $$ = ProductionRule(n, ProductionRuleKind.terminal, e, t);
                $2 = $$;
              }
            }
          }
        }
      }
      if (_success) {
        break;
      } else {
        _c = $4;
        _pos = $5;
      }
      final $15 = _parse_terminal_name(83, $1);
      if (_success) {
        _parse_$EqualSign(84, false);
        if (_success) {
          final $17 = _parseExpression(85, $1);
          if (_success) {
            _parse_$Semicolon(86, false);
            if (_success) {
              final n = $15;
              final e = $17;
              ProductionRule $$;
              $$ = ProductionRule(n, ProductionRuleKind.terminal, e, null);
              $2 = $$;
            }
          }
        }
      }
      if (_success) {
      } else {
        _c = $4;
        _pos = $5;
      }
      break;
    }
    if (!_success) {
      if ($5 == _error) {
        _expected.addAll(
            const ['\'terminal name\'', '\'library prefix\'', '\'type name\'']);
      }
    }
    return $2;
  }

  OrderedChoiceExpression _parseExpression(int $0, bool $1) {
    OrderedChoiceExpression $2;
    final $4 = _c;
    final $5 = _pos;
    final $8 = _parseSequence(89, $1);
    if (_success) {
      List<SequenceExpression> $9;
      if ($1) {
        $9 = [];
      }
      for (;;) {
        SequenceExpression $10;
        final $11 = _c;
        final $12 = _pos;
        _parse_$Slash(93, false);
        if (_success) {
          $10 = _parseSequence(94, $1);
        }
        if (!_success) {
          _c = $11;
          _pos = $12;
          if ($12 == _error) {
            _expected.add('\'/\'');
          }
        }
        if (!_success) {
          break;
        }
        if ($1) {
          $9.add($10);
        }
      }
      _success = true;
      {
        final e = $8;
        final n = $9;
        OrderedChoiceExpression $$;
        $$ = OrderedChoiceExpression([e, ...n]);
        $2 = $$;
      }
    }
    if (!_success) {
      _c = $4;
      _pos = $5;
      if ($5 == _error) {
        _expected.addAll(const [
          '\'sub terminal name\'',
          '\'(\'',
          '\'literal\'',
          '\'character class\'',
          '\'.\'',
          '\'<\''
        ]);
      }
    }
    return $2;
  }

  SequenceExpression _parseSequence(int $0, bool $1) {
    SequenceExpression $2;
    final $4 = _c;
    final $5 = _pos;
    List<Expression> $8;
    if ($1) {
      $8 = [];
    }
    var $9 = false;
    for (;;) {
      final $10 = _parsePrefix(98, $1);
      if (!_success) {
        _success = $9;
        if (!_success) {
          $8 = null;
        }
        break;
      }
      if ($1) {
        $8.add($10);
      }
      $9 = true;
    }
    if (_success) {
      final $11 = _parse_action(100, $1);
      _success = true;
      {
        final e = $8;
        final a = $11;
        SequenceExpression $$;
        $$ = SequenceExpression(e, a);
        $2 = $$;
      }
    }
    if (!_success) {
      _c = $4;
      _pos = $5;
      if ($5 == _error) {
        _expected.addAll(const [
          '\'sub terminal name\'',
          '\'(\'',
          '\'literal\'',
          '\'character class\'',
          '\'.\'',
          '\'<\''
        ]);
      }
    }
    return $2;
  }

  Expression _parsePrefix(int $0, bool $1) {
    Expression $2;
    final $4 = _c;
    final $5 = _pos;
    final $8 = _parse_semantic_value(104, $1);
    _success = true;
    String $9;
    final $10 = _c;
    final $11 = _pos;
    final $12 = _pos;
    for (;;) {
      $9 = _parse_$Ampersand(108, $1);
      if (_success) {
        break;
      } else {
        _c = $10;
        _pos = $11;
      }
      $9 = _parse_$ExclamationMark(110, $1);
      if (_success) {
      } else {
        _c = $10;
        _pos = $11;
      }
      break;
    }
    if (!_success) {
      if ($12 == _error) {
        _expected.addAll(const ['\'&\'', '\'!\'']);
      }
    }
    _success = true;
    final $19 = _parseSuffix(111, $1);
    if (_success) {
      final s = $8;
      final p = $9;
      final e = $19;
      Expression $$;
      $$ = _prefix(p, e, s);
      $2 = $$;
    }
    if (!_success) {
      _c = $4;
      _pos = $5;
      if ($5 == _error) {
        _expected.addAll(const [
          '\'sub terminal name\'',
          '\'(\'',
          '\'literal\'',
          '\'character class\'',
          '\'.\'',
          '\'<\''
        ]);
      }
    }
    return $2;
  }

  Expression _parseSuffix(int $0, bool $1) {
    Expression $2;
    final $4 = _c;
    final $5 = _pos;
    final $8 = _parsePrimary(114, $1);
    if (_success) {
      String $9;
      final $10 = _c;
      final $11 = _pos;
      final $12 = _pos;
      for (;;) {
        $9 = _parse_$QuestionMark(118, $1);
        if (_success) {
          break;
        } else {
          _c = $10;
          _pos = $11;
        }
        $9 = _parse_$Asterisk(120, $1);
        if (_success) {
          break;
        } else {
          _c = $10;
          _pos = $11;
        }
        $9 = _parse_$PlusSign(122, $1);
        if (_success) {
        } else {
          _c = $10;
          _pos = $11;
        }
        break;
      }
      if (!_success) {
        if ($12 == _error) {
          _expected.addAll(const ['\'?\'', '\'*\'', '\'+\'']);
        }
      }
      _success = true;
      {
        final e = $8;
        final s = $9;
        Expression $$;
        $$ = _suffix(s, e);
        $2 = $$;
      }
    }
    if (!_success) {
      _c = $4;
      _pos = $5;
      if ($5 == _error) {
        _expected.addAll(const [
          '\'sub terminal name\'',
          '\'(\'',
          '\'literal\'',
          '\'character class\'',
          '\'.\'',
          '\'<\''
        ]);
      }
    }
    return $2;
  }

  Expression _parsePrimary(int $0, bool $1) {
    Expression $2;
    final $4 = _c;
    final $5 = _pos;
    for (;;) {
      final $8 = _parse_sub_terminal_name(125, $1);
      if (_success) {
        final n = $8;
        Expression $$;
        $$ = SubterminalExpression(n);
        $2 = $$;
      }
      if (_success) {
        break;
      } else {
        _c = $4;
        _pos = $5;
      }
      _parse_$LeftParenthesis(127, false);
      if (_success) {
        $2 = _parseExpression(128, $1);
        if (_success) {
          _parse_$RightParenthesis(129, false);
        }
      }
      if (_success) {
        break;
      } else {
        _c = $4;
        _pos = $5;
      }
      $2 = _parse_literal(131, $1);
      if (_success) {
        break;
      } else {
        _c = $4;
        _pos = $5;
      }
      $2 = _parse_character_class(133, $1);
      if (_success) {
        break;
      } else {
        _c = $4;
        _pos = $5;
      }
      _parse_$Period(135, $1);
      if (_success) {
        Expression $$;
        $$ = AnyCharacterExpression();
        $2 = $$;
      }
      if (_success) {
        break;
      } else {
        _c = $4;
        _pos = $5;
      }
      _parse_$LessThanSign(137, false);
      if (_success) {
        final $26 = _parseExpression(138, $1);
        if (_success) {
          _parse_$GreaterThanSign(139, false);
          if (_success) {
            final e = $26;
            Expression $$;
            $$ = CaptureExpression(e);
            $2 = $$;
          }
        }
      }
      if (_success) {
      } else {
        _c = $4;
        _pos = $5;
      }
      break;
    }
    if (!_success) {
      if ($5 == _error) {
        _expected.addAll(const [
          '\'sub terminal name\'',
          '\'(\'',
          '\'literal\'',
          '\'character class\'',
          '\'.\'',
          '\'<\''
        ]);
      }
    }
    return $2;
  }

  ProductionRule _parseSubterminalDefinition(int $0, bool $1) {
    ProductionRule $2;
    final $4 = _c;
    final $5 = _pos;
    for (;;) {
      final $8 = _parseType(142, $1);
      if (_success) {
        final $9 = _parse_sub_terminal_name(143, $1);
        if (_success) {
          _parse_$EqualSign(144, false);
          if (_success) {
            final $11 = _parseExpression(145, $1);
            if (_success) {
              _parse_$Semicolon(146, false);
              if (_success) {
                final t = $8;
                final n = $9;
                final e = $11;
                ProductionRule $$;
                $$ = ProductionRule(n, ProductionRuleKind.subterminal, e, t);
                $2 = $$;
              }
            }
          }
        }
      }
      if (_success) {
        break;
      } else {
        _c = $4;
        _pos = $5;
      }
      final $15 = _parse_sub_terminal_name(148, $1);
      if (_success) {
        _parse_$EqualSign(149, false);
        if (_success) {
          final $17 = _parseExpression(150, $1);
          if (_success) {
            _parse_$Semicolon(151, false);
            if (_success) {
              final n = $15;
              final e = $17;
              ProductionRule $$;
              $$ = ProductionRule(n, ProductionRuleKind.subterminal, e, null);
              $2 = $$;
            }
          }
        }
      }
      if (_success) {
      } else {
        _c = $4;
        _pos = $5;
      }
      break;
    }
    if (!_success) {
      if ($5 == _error) {
        _expected.addAll(const [
          '\'sub terminal name\'',
          '\'library prefix\'',
          '\'type name\''
        ]);
      }
    }
    return $2;
  }

  String _parseType(int $0, bool $1) {
    String $2;
    final $4 = _c;
    final $5 = _pos;
    final $8 = _parseTypeName(154, $1);
    if (_success) {
      List<String> $9;
      final $10 = _c;
      final $11 = _pos;
      final $12 = _pos;
      _parse_$LessThanSign(158, false);
      if (_success) {
        $9 = _parseTypeArguments(159, $1);
        if (_success) {
          _parse_$GreaterThanSign(160, false);
        }
      }
      if (!_success) {
        _c = $10;
        _pos = $11;
        if ($12 == _error) {
          _expected.add('\'<\'');
        }
      }
      _success = true;
      {
        final n = $8;
        final a = $9;
        String $$;
        $$ = n + (a == null ? '' : '<' + a.join(', ') + '>');
        $2 = $$;
      }
    }
    if (!_success) {
      _c = $4;
      _pos = $5;
      if ($5 == _error) {
        _expected.addAll(const ['\'library prefix\'', '\'type name\'']);
      }
    }
    return $2;
  }

  String _parseTypeName(int $0, bool $1) {
    String $2;
    final $4 = _c;
    final $5 = _pos;
    for (;;) {
      final $8 = _parse_library_prefix(163, $1);
      if (_success) {
        _parse_$Period(164, false);
        if (_success) {
          final $10 = _parse_type_name(165, $1);
          if (_success) {
            final p = $8;
            final n = $10;
            String $$;
            $$ = '$p.$n';
            $2 = $$;
          }
        }
      }
      if (_success) {
        break;
      } else {
        _c = $4;
        _pos = $5;
      }
      $2 = _parse_type_name(167, $1);
      if (_success) {
      } else {
        _c = $4;
        _pos = $5;
      }
      break;
    }
    if (!_success) {
      if ($5 == _error) {
        _expected.addAll(const ['\'library prefix\'', '\'type name\'']);
      }
    }
    return $2;
  }

  List<String> _parseTypeArguments(int $0, bool $1) {
    List<String> $2;
    final $4 = _c;
    final $5 = _pos;
    final $8 = _parseType(170, $1);
    if (_success) {
      List<String> $9;
      if ($1) {
        $9 = [];
      }
      for (;;) {
        String $10;
        final $11 = _c;
        final $12 = _pos;
        _parse_$Comma(174, false);
        if (_success) {
          $10 = _parseType(175, $1);
        }
        if (!_success) {
          _c = $11;
          _pos = $12;
          if ($12 == _error) {
            _expected.add('\',\'');
          }
        }
        if (!_success) {
          break;
        }
        if ($1) {
          $9.add($10);
        }
      }
      _success = true;
      {
        final t = $8;
        final n = $9;
        List<String> $$;
        $$ = [t, ...n];
        $2 = $$;
      }
    }
    if (!_success) {
      _c = $4;
      _pos = $5;
      if ($5 == _error) {
        _expected.addAll(const ['\'library prefix\'', '\'type name\'']);
      }
    }
    return $2;
  }

  String _parse_non_terminal_name(int $0, bool $1) {
    String $2;
    final $5 = _c;
    final $6 = _pos;
    $2 = _parse$$IDENTIFIER(178, $1);
    if (_success) {
      _parse$$SPACING(179, false);
    }
    if (!_success) {
      _c = $5;
      _pos = $6;
      if (_error < _failure) {
        _error = _failure;
        _expected = [];
      }
      if (_error == _failure) {
        _expected.add('\'non terminal name\'');
      }
    }
    return $2;
  }

  String _parse_terminal_name(int $0, bool $1) {
    String $2;
    final $5 = _c;
    final $6 = _pos;
    final $10 = $1;
    $1 = false;
    if (_success = _c == 39) {
      _c = _input[++_pos];
    } else {
      _failure = _pos;
    }
    if (_success) {
      var $17 = false;
      for (;;) {
        final $20 = _c;
        final $21 = _pos;
        final $24 = _predicate;
        final $25 = $1;
        _predicate = true;
        $1 = false;
        if (_success = _c == 39) {
          _c = _input[++_pos];
        } else {
          _failure = _pos;
        }
        _c = $20;
        _pos = $21;
        _predicate = $24;
        $1 = $25;
        _success = !_success;
        if (_success) {
          _parse$$TERMINAL_CHAR(191, false);
        }
        if (!_success) {
          _c = $20;
          _pos = $21;
          _success = $17;
          break;
        }
        $17 = true;
      }
      if (_success) {
        if (_success = _c == 39) {
          _c = _input[++_pos];
        } else {
          _failure = _pos;
        }
      }
    }
    if (!_success) {
      _c = $5;
      _pos = $6;
    } else {
      $2 = _text.substring($6, _pos);
    }
    $1 = $10;
    if (_success) {
      _parse$$SPACING(193, false);
    }
    if (!_success) {
      _c = $5;
      _pos = $6;
      if (_error < _failure) {
        _error = _failure;
        _expected = [];
      }
      if (_error == _failure) {
        _expected.add('\'terminal name\'');
      }
    }
    return $2;
  }

  String _parse_sub_terminal_name(int $0, bool $1) {
    String $2;
    final $5 = _c;
    final $6 = _pos;
    final $10 = $1;
    $1 = false;
    if (_success = _c == 64) {
      _c = _input[++_pos];
    } else {
      _failure = _pos;
    }
    if (_success) {
      _parse$$IDENTIFIER(200, false);
    }
    if (!_success) {
      _c = $5;
      _pos = $6;
    } else {
      $2 = _text.substring($6, _pos);
    }
    $1 = $10;
    if (_success) {
      _parse$$SPACING(201, false);
    }
    if (!_success) {
      _c = $5;
      _pos = $6;
      if (_error < _failure) {
        _error = _failure;
        _expected = [];
      }
      if (_error == _failure) {
        _expected.add('\'sub terminal name\'');
      }
    }
    return $2;
  }

  String _parse_semantic_value(int $0, bool $1) {
    String $2;
    final $5 = _c;
    final $6 = _pos;
    $2 = _parse$$IDENTIFIER(204, $1);
    if (_success) {
      if (_success = _c == 58) {
        _c = _input[++_pos];
      } else {
        _failure = _pos;
      }
    }
    if (!_success) {
      _c = $5;
      _pos = $6;
      if (_error < _failure) {
        _error = _failure;
        _expected = [];
      }
      if (_error == _failure) {
        _expected.add('\'semantic value\'');
      }
    }
    return $2;
  }

  String _parse_type_name(int $0, bool $1) {
    String $2;
    final $5 = _c;
    final $6 = _pos;
    final $10 = $1;
    $1 = false;
    _parse$$IDENTIFIER(211, false);
    if (_success) {
      if (_success = _c == 63) {
        _c = _input[++_pos];
      } else {
        _failure = _pos;
      }
      _success = true;
    }
    if (!_success) {
      _c = $5;
      _pos = $6;
    } else {
      $2 = _text.substring($6, _pos);
    }
    $1 = $10;
    if (_success) {
      _parse$$SPACING(214, false);
    }
    if (!_success) {
      _c = $5;
      _pos = $6;
      if (_error < _failure) {
        _error = _failure;
        _expected = [];
      }
      if (_error == _failure) {
        _expected.add('\'type name\'');
      }
    }
    return $2;
  }

  String _parse_library_prefix(int $0, bool $1) {
    String $2;
    final $5 = _c;
    final $6 = _pos;
    final $10 = $1;
    $1 = false;
    if (_success = _c == 95) {
      _c = _input[++_pos];
    } else {
      _failure = _pos;
    }
    _success = true;
    _parse$$IDENTIFIER(222, false);
    if (!_success) {
      _c = $5;
      _pos = $6;
    } else {
      $2 = _text.substring($6, _pos);
    }
    $1 = $10;
    if (!_success) {
      _c = $5;
      _pos = $6;
      if (_error < _failure) {
        _error = _failure;
        _expected = [];
      }
      if (_error == _failure) {
        _expected.add('\'library prefix\'');
      }
    }
    return $2;
  }

  String _parse_$Semicolon(int $0, bool $1) {
    String $2;
    final $5 = _c;
    final $6 = _pos;
    if (_success = _c == 59) {
      $2 = ';';
      _c = _input[++_pos];
    } else {
      _failure = _pos;
    }
    if (_success) {
      _parse$$SPACING(226, false);
    }
    if (!_success) {
      _c = $5;
      _pos = $6;
      if (_error < _failure) {
        _error = _failure;
        _expected = [];
      }
      if (_error == _failure) {
        _expected.add('\';\'');
      }
    }
    return $2;
  }

  String _parse_action(int $0, bool $1) {
    String $2;
    final $5 = _c;
    final $6 = _pos;
    if (_success = _c == 123) {
      _c = _input[++_pos];
    } else {
      _failure = _pos;
    }
    if (_success) {
      final $11 = $1;
      final $12 = _pos;
      $1 = false;
      final $15 = _c;
      for (;;) {
        _parse$$ACTION_BODY(234, false);
        if (!_success) {
          break;
        }
      }
      _success = true;
      if (!_success) {
        _c = $15;
        _pos = $12;
      } else {
        $2 = _text.substring($12, _pos);
      }
      $1 = $11;
      if (_success = _c == 125) {
        _c = _input[++_pos];
      } else {
        _failure = _pos;
      }
      if (_success) {
        _parse$$SPACING(236, false);
      }
    }
    if (!_success) {
      _c = $5;
      _pos = $6;
      if (_error < _failure) {
        _error = _failure;
        _expected = [];
      }
      if (_error == _failure) {
        _expected.add('\'action\'');
      }
    }
    return $2;
  }

  String _parse_$Ampersand(int $0, bool $1) {
    String $2;
    final $5 = _c;
    final $6 = _pos;
    if (_success = _c == 38) {
      $2 = '&';
      _c = _input[++_pos];
    } else {
      _failure = _pos;
    }
    if (_success) {
      _parse$$SPACING(240, false);
    }
    if (!_success) {
      _c = $5;
      _pos = $6;
      if (_error < _failure) {
        _error = _failure;
        _expected = [];
      }
      if (_error == _failure) {
        _expected.add('\'&\'');
      }
    }
    return $2;
  }

  Expression _parse_character_class(int $0, bool $1) {
    Expression $2;
    final $5 = _c;
    final $6 = _pos;
    if (_success = _c == 91) {
      _c = _input[++_pos];
    } else {
      _failure = _pos;
    }
    if (_success) {
      List<List<int>> $10;
      if ($1) {
        $10 = [];
      }
      var $11 = false;
      for (;;) {
        List<int> $12;
        final $14 = _c;
        final $15 = _pos;
        final $18 = _predicate;
        final $19 = $1;
        _predicate = true;
        $1 = false;
        if (_success = _c == 93) {
          _c = _input[++_pos];
        } else {
          _failure = _pos;
        }
        _c = $14;
        _pos = $15;
        _predicate = $18;
        $1 = $19;
        _success = !_success;
        if (_success) {
          $12 = _parse$$RANGE(249, $1);
        }
        if (!_success) {
          _c = $14;
          _pos = $15;
          _success = $11;
          if (!_success) {
            $10 = null;
          }
          break;
        }
        if ($1) {
          $10.add($12);
        }
        $11 = true;
      }
      if (_success) {
        if (_success = _c == 93) {
          _c = _input[++_pos];
        } else {
          _failure = _pos;
        }
        if (_success) {
          _parse$$SPACING(251, false);
          if (_success) {
            final r = $10;
            Expression $$;
            $$ = CharacterClassExpression(r);
            $2 = $$;
          }
        }
      }
    }
    if (!_success) {
      _c = $5;
      _pos = $6;
      if (_error < _failure) {
        _error = _failure;
        _expected = [];
      }
      if (_error == _failure) {
        _expected.add('\'character class\'');
      }
    }
    return $2;
  }

  String _parse_$RightParenthesis(int $0, bool $1) {
    String $2;
    final $5 = _c;
    final $6 = _pos;
    if (_success = _c == 41) {
      $2 = ')';
      _c = _input[++_pos];
    } else {
      _failure = _pos;
    }
    if (_success) {
      _parse$$SPACING(255, false);
    }
    if (!_success) {
      _c = $5;
      _pos = $6;
      if (_error < _failure) {
        _error = _failure;
        _expected = [];
      }
      if (_error == _failure) {
        _expected.add('\')\'');
      }
    }
    return $2;
  }

  String _parse_$Period(int $0, bool $1) {
    String $2;
    final $5 = _c;
    final $6 = _pos;
    if (_success = _c == 46) {
      $2 = '.';
      _c = _input[++_pos];
    } else {
      _failure = _pos;
    }
    if (_success) {
      _parse$$SPACING(259, false);
    }
    if (!_success) {
      _c = $5;
      _pos = $6;
      if (_error < _failure) {
        _error = _failure;
        _expected = [];
      }
      if (_error == _failure) {
        _expected.add('\'.\'');
      }
    }
    return $2;
  }

  dynamic _parse_end_of_file(int $0, bool $1) {
    dynamic $2;
    final $5 = _c;
    final $6 = _pos;
    final $9 = _predicate;
    final $10 = $1;
    _predicate = true;
    $1 = false;
    if (_success = _c < _eof) {
      _c = _input[_pos += _c <= 65535 ? 1 : 2];
    } else {
      _failure = _pos;
    }
    _c = $5;
    _pos = $6;
    _predicate = $9;
    $1 = $10;
    _success = !_success;
    if (!_success) {
      _c = $5;
      _pos = $6;
      if (_error < _failure) {
        _error = _failure;
        _expected = [];
      }
      if (_error == _failure) {
        _expected.add('\'end of file\'');
      }
    }
    return $2;
  }

  String _parse_globals(int $0, bool $1) {
    String $2;
    final $5 = _c;
    final $6 = _pos;
    if (_success = _c == 37) {
      _matchString('%{');
    } else {
      _failure = _pos;
    }
    if (_success) {
      final $11 = $1;
      final $12 = _pos;
      $1 = false;
      final $15 = _c;
      for (;;) {
        _parse$$GLOBALS_BODY(271, false);
        if (!_success) {
          break;
        }
      }
      _success = true;
      if (!_success) {
        _c = $15;
        _pos = $12;
      } else {
        $2 = _text.substring($12, _pos);
      }
      $1 = $11;
      if (_success = _c == 125) {
        _matchString('}%');
      } else {
        _failure = _pos;
      }
      if (_success) {
        _parse$$SPACING(273, false);
      }
    }
    if (!_success) {
      _c = $5;
      _pos = $6;
      if (_error < _failure) {
        _error = _failure;
        _expected = [];
      }
      if (_error == _failure) {
        _expected.add('\'globals\'');
      }
    }
    return $2;
  }

  List _parse_leading_spaces(int $0, bool $1) {
    List $2;
    final $5 = _c;
    final $6 = _pos;
    $2 = _parse$$SPACING(276, false);
    if (!_success) {
      _c = $5;
      _pos = $6;
      if (_error < _failure) {
        _error = _failure;
        _expected = [];
      }
      if (_error == _failure) {
        _expected.add('\'leading spaces\'');
      }
    }
    return $2;
  }

  String _parse_$EqualSign(int $0, bool $1) {
    String $2;
    final $5 = _c;
    final $6 = _pos;
    if (_success = _c == 61) {
      $2 = '=';
      _c = _input[++_pos];
    } else {
      _failure = _pos;
    }
    if (_success) {
      _parse$$SPACING(280, false);
    }
    if (!_success) {
      _c = $5;
      _pos = $6;
      if (_error < _failure) {
        _error = _failure;
        _expected = [];
      }
      if (_error == _failure) {
        _expected.add('\'=\'');
      }
    }
    return $2;
  }

  Expression _parse_literal(int $0, bool $1) {
    Expression $2;
    final $5 = _c;
    final $6 = _pos;
    if (_success = _c == 34) {
      _c = _input[++_pos];
    } else {
      _failure = _pos;
    }
    if (_success) {
      List<int> $10;
      if ($1) {
        $10 = [];
      }
      for (;;) {
        int $11;
        final $13 = _c;
        final $14 = _pos;
        final $17 = _predicate;
        final $18 = $1;
        _predicate = true;
        $1 = false;
        if (_success = _c == 34) {
          _c = _input[++_pos];
        } else {
          _failure = _pos;
        }
        _c = $13;
        _pos = $14;
        _predicate = $17;
        $1 = $18;
        _success = !_success;
        if (_success) {
          $11 = _parse$$LITERAL_CHAR(289, $1);
        }
        if (!_success) {
          _c = $13;
          _pos = $14;
          break;
        }
        if ($1) {
          $10.add($11);
        }
      }
      _success = true;
      if (_success = _c == 34) {
        _c = _input[++_pos];
      } else {
        _failure = _pos;
      }
      if (_success) {
        _parse$$SPACING(291, false);
        if (_success) {
          final c = $10;
          Expression $$;
          $$ = LiteralExpression(String.fromCharCodes(c));
          $2 = $$;
        }
      }
    }
    if (!_success) {
      _c = $5;
      _pos = $6;
      if (_error < _failure) {
        _error = _failure;
        _expected = [];
      }
      if (_error == _failure) {
        _expected.add('\'literal\'');
      }
    }
    return $2;
  }

  String _parse_members(int $0, bool $1) {
    String $2;
    final $5 = _c;
    final $6 = _pos;
    if (_success = _c == 123) {
      _c = _input[++_pos];
    } else {
      _failure = _pos;
    }
    if (_success) {
      final $11 = $1;
      final $12 = _pos;
      $1 = false;
      final $15 = _c;
      for (;;) {
        _parse$$ACTION_BODY(299, false);
        if (!_success) {
          break;
        }
      }
      _success = true;
      if (!_success) {
        _c = $15;
        _pos = $12;
      } else {
        $2 = _text.substring($12, _pos);
      }
      $1 = $11;
      if (_success = _c == 125) {
        _c = _input[++_pos];
      } else {
        _failure = _pos;
      }
      if (_success) {
        _parse$$SPACING(301, false);
      }
    }
    if (!_success) {
      _c = $5;
      _pos = $6;
      if (_error < _failure) {
        _error = _failure;
        _expected = [];
      }
      if (_error == _failure) {
        _expected.add('\'members\'');
      }
    }
    return $2;
  }

  String _parse_$ExclamationMark(int $0, bool $1) {
    String $2;
    final $5 = _c;
    final $6 = _pos;
    if (_success = _c == 33) {
      $2 = '!';
      _c = _input[++_pos];
    } else {
      _failure = _pos;
    }
    if (_success) {
      _parse$$SPACING(305, false);
    }
    if (!_success) {
      _c = $5;
      _pos = $6;
      if (_error < _failure) {
        _error = _failure;
        _expected = [];
      }
      if (_error == _failure) {
        _expected.add('\'!\'');
      }
    }
    return $2;
  }

  String _parse_$LeftParenthesis(int $0, bool $1) {
    String $2;
    final $5 = _c;
    final $6 = _pos;
    if (_success = _c == 40) {
      $2 = '(';
      _c = _input[++_pos];
    } else {
      _failure = _pos;
    }
    if (_success) {
      _parse$$SPACING(309, false);
    }
    if (!_success) {
      _c = $5;
      _pos = $6;
      if (_error < _failure) {
        _error = _failure;
        _expected = [];
      }
      if (_error == _failure) {
        _expected.add('\'(\'');
      }
    }
    return $2;
  }

  String _parse_$PlusSign(int $0, bool $1) {
    String $2;
    final $5 = _c;
    final $6 = _pos;
    if (_success = _c == 43) {
      $2 = '+';
      _c = _input[++_pos];
    } else {
      _failure = _pos;
    }
    if (_success) {
      _parse$$SPACING(313, false);
    }
    if (!_success) {
      _c = $5;
      _pos = $6;
      if (_error < _failure) {
        _error = _failure;
        _expected = [];
      }
      if (_error == _failure) {
        _expected.add('\'+\'');
      }
    }
    return $2;
  }

  String _parse_$Comma(int $0, bool $1) {
    String $2;
    final $5 = _c;
    final $6 = _pos;
    if (_success = _c == 44) {
      $2 = ',';
      _c = _input[++_pos];
    } else {
      _failure = _pos;
    }
    if (_success) {
      _parse$$SPACING(317, false);
    }
    if (!_success) {
      _c = $5;
      _pos = $6;
      if (_error < _failure) {
        _error = _failure;
        _expected = [];
      }
      if (_error == _failure) {
        _expected.add('\',\'');
      }
    }
    return $2;
  }

  String _parse_$QuestionMark(int $0, bool $1) {
    String $2;
    final $5 = _c;
    final $6 = _pos;
    if (_success = _c == 63) {
      $2 = '?';
      _c = _input[++_pos];
    } else {
      _failure = _pos;
    }
    if (_success) {
      _parse$$SPACING(321, false);
    }
    if (!_success) {
      _c = $5;
      _pos = $6;
      if (_error < _failure) {
        _error = _failure;
        _expected = [];
      }
      if (_error == _failure) {
        _expected.add('\'?\'');
      }
    }
    return $2;
  }

  String _parse_$Slash(int $0, bool $1) {
    String $2;
    final $5 = _c;
    final $6 = _pos;
    if (_success = _c == 47) {
      $2 = '/';
      _c = _input[++_pos];
    } else {
      _failure = _pos;
    }
    if (_success) {
      _parse$$SPACING(325, false);
    }
    if (!_success) {
      _c = $5;
      _pos = $6;
      if (_error < _failure) {
        _error = _failure;
        _expected = [];
      }
      if (_error == _failure) {
        _expected.add('\'/\'');
      }
    }
    return $2;
  }

  String _parse_$Asterisk(int $0, bool $1) {
    String $2;
    final $5 = _c;
    final $6 = _pos;
    if (_success = _c == 42) {
      $2 = '*';
      _c = _input[++_pos];
    } else {
      _failure = _pos;
    }
    if (_success) {
      _parse$$SPACING(329, false);
    }
    if (!_success) {
      _c = $5;
      _pos = $6;
      if (_error < _failure) {
        _error = _failure;
        _expected = [];
      }
      if (_error == _failure) {
        _expected.add('\'*\'');
      }
    }
    return $2;
  }

  String _parse_$LessThanSign(int $0, bool $1) {
    String $2;
    final $5 = _c;
    final $6 = _pos;
    if (_success = _c == 60) {
      $2 = '<';
      _c = _input[++_pos];
    } else {
      _failure = _pos;
    }
    if (_success) {
      _parse$$SPACING(333, false);
    }
    if (!_success) {
      _c = $5;
      _pos = $6;
      if (_error < _failure) {
        _error = _failure;
        _expected = [];
      }
      if (_error == _failure) {
        _expected.add('\'<\'');
      }
    }
    return $2;
  }

  String _parse_$GreaterThanSign(int $0, bool $1) {
    String $2;
    final $5 = _c;
    final $6 = _pos;
    if (_success = _c == 62) {
      $2 = '>';
      _c = _input[++_pos];
    } else {
      _failure = _pos;
    }
    if (_success) {
      _parse$$SPACING(337, false);
    }
    if (!_success) {
      _c = $5;
      _pos = $6;
      if (_error < _failure) {
        _error = _failure;
        _expected = [];
      }
      if (_error == _failure) {
        _expected.add('\'>\'');
      }
    }
    return $2;
  }

  dynamic _parse$$ACTION_BODY(int $0, bool $1) {
    dynamic $2;
    final $4 = _c;
    final $5 = _pos;
    for (;;) {
      if (_success = _c == 123) {
        $2 = '{';
        _c = _input[++_pos];
      } else {
        _failure = _pos;
      }
      if (_success) {
        for (;;) {
          _parse$$ACTION_BODY(342, false);
          if (!_success) {
            break;
          }
        }
        _success = true;
        if (_success = _c == 125) {
          _c = _input[++_pos];
        } else {
          _failure = _pos;
        }
      }
      if (_success) {
        break;
      } else {
        _c = $4;
        _pos = $5;
      }
      final $14 = _predicate;
      final $15 = $1;
      _predicate = true;
      $1 = false;
      if (_success = _c == 125) {
        _c = _input[++_pos];
      } else {
        _failure = _pos;
      }
      _c = $4;
      _pos = $5;
      _predicate = $14;
      $1 = $15;
      _success = !_success;
      if (_success) {
        if (_success = _c < _eof) {
          _c = _input[_pos += _c <= 65535 ? 1 : 2];
        } else {
          _failure = _pos;
        }
      }
      if (_success) {
      } else {
        _c = $4;
        _pos = $5;
      }
      break;
    }
    return $2;
  }

  String _parse$$COMMENT(int $0, bool $1) {
    String $2;
    final $4 = _c;
    final $5 = _pos;
    if (_success = _c == 35) {
      $2 = '#';
      _c = _input[++_pos];
    } else {
      _failure = _pos;
    }
    if (_success) {
      for (;;) {
        final $11 = _c;
        final $12 = _pos;
        final $15 = _predicate;
        final $16 = $1;
        _predicate = true;
        $1 = false;
        _parse$$EOL(355, false);
        _c = $11;
        _pos = $12;
        _predicate = $15;
        $1 = $16;
        _success = !_success;
        if (_success) {
          if (_success = _c < _eof) {
            _c = _input[_pos += _c <= 65535 ? 1 : 2];
          } else {
            _failure = _pos;
          }
        }
        if (!_success) {
          _c = $11;
          _pos = $12;
          break;
        }
      }
      _success = true;
      _parse$$EOL(358, false);
      _success = true;
    }
    if (!_success) {
      _c = $4;
      _pos = $5;
    }
    return $2;
  }

  dynamic _parse$$EOL(int $0, bool $1) {
    dynamic $2;
    final $4 = _c;
    final $5 = _pos;
    for (;;) {
      if (_success = _c == 13) {
        $2 = _matchString('\r\n');
      } else {
        _failure = _pos;
      }
      if (_success) {
        break;
      } else {
        _c = $4;
        _pos = $5;
      }
      if (_success = _c == 10 || _c == 13) {
        $2 = _c;
        _c = _input[++_pos];
      } else {
        _failure = _pos;
      }
      if (_success) {
      } else {
        _c = $4;
        _pos = $5;
      }
      break;
    }
    return $2;
  }

  dynamic _parse$$GLOBALS_BODY(int $0, bool $1) {
    dynamic $2;
    final $4 = _c;
    final $5 = _pos;
    final $8 = _predicate;
    final $9 = $1;
    _predicate = true;
    $1 = false;
    if (_success = _c == 125) {
      _matchString('}%');
    } else {
      _failure = _pos;
    }
    _c = $4;
    _pos = $5;
    _predicate = $8;
    $1 = $9;
    _success = !_success;
    if (_success) {
      if (_success = _c < _eof) {
        _c = _input[_pos += _c <= 65535 ? 1 : 2];
      } else {
        _failure = _pos;
      }
    }
    if (!_success) {
      _c = $4;
      _pos = $5;
    }
    return $2;
  }

  int _parse$$HEX_NUMBER(int $0, bool $1) {
    int $2;
    final $4 = _c;
    final $5 = _pos;
    if (_success = _c == 92) {
      _c = _input[++_pos];
    } else {
      _failure = _pos;
    }
    if (_success) {
      if (_success = _c == 117) {
        _c = _input[++_pos];
      } else {
        _failure = _pos;
      }
      if (_success) {
        String $10;
        final $11 = $1;
        final $12 = _pos;
        $1 = false;
        final $14 = _c;
        var $18 = false;
        for (;;) {
          if (_success = _c >= 48 && _c <= 57 ||
              _c >= 65 && _c <= 70 ||
              _c >= 97 && _c <= 102) {
            _c = _input[++_pos];
          } else {
            _failure = _pos;
          }
          if (!_success) {
            _success = $18;
            break;
          }
          $18 = true;
        }
        if (!_success) {
          _c = $14;
          _pos = $12;
        } else {
          $10 = _text.substring($12, _pos);
        }
        $1 = $11;
        if (_success) {
          final d = $10;
          int $$;
          $$ = int.parse(d, radix: 16);
          $2 = $$;
        }
      }
    }
    if (!_success) {
      _c = $4;
      _pos = $5;
    }
    return $2;
  }

  String _parse$$IDENTIFIER(int $0, bool $1) {
    String $2;
    final $4 = _c;
    final $5 = _pos;
    final $9 = $1;
    $1 = false;
    _parse$$IDENT_START(383, false);
    if (_success) {
      for (;;) {
        _parse$$IDENT_CONT(385, false);
        if (!_success) {
          break;
        }
      }
      _success = true;
    }
    if (!_success) {
      _c = $4;
      _pos = $5;
    } else {
      $2 = _text.substring($5, _pos);
    }
    $1 = $9;
    if (!_success) {
      _c = $4;
      _pos = $5;
    }
    return $2;
  }

  int _parse$$IDENT_CONT(int $0, bool $1) {
    int $2;
    final $4 = _c;
    final $5 = _pos;
    for (;;) {
      $2 = _parse$$IDENT_START(388, false);
      if (_success) {
        break;
      } else {
        _c = $4;
        _pos = $5;
      }
      if (_success = _c >= 48 && _c <= 57 || _c == 95) {
        $2 = _c;
        _c = _input[++_pos];
      } else {
        _failure = _pos;
      }
      if (_success) {
      } else {
        _c = $4;
        _pos = $5;
      }
      break;
    }
    return $2;
  }

  int _parse$$IDENT_START(int $0, bool $1) {
    int $2;
    final $4 = _c;
    final $5 = _pos;
    if (_success = _c >= 65 && _c <= 90 || _c >= 97 && _c <= 122) {
      $2 = _c;
      _c = _input[++_pos];
    } else {
      _failure = _pos;
    }
    if (!_success) {
      _c = $4;
      _pos = $5;
    }
    return $2;
  }

  int _parse$$LITERAL_CHAR(int $0, bool $1) {
    int $2;
    final $4 = _c;
    final $5 = _pos;
    for (;;) {
      if (_success = _c == 92) {
        _c = _input[++_pos];
      } else {
        _failure = _pos;
      }
      if (_success) {
        int $9;
        if (_success =
            _c == 34 || _c == 92 || _c == 110 || _c == 114 || _c == 116) {
          $9 = _c;
          _c = _input[++_pos];
        } else {
          _failure = _pos;
        }
        if (_success) {
          final c = $9;
          int $$;
          $$ = _escape(c);
          $2 = $$;
        }
      }
      if (_success) {
        break;
      } else {
        _c = $4;
        _pos = $5;
      }
      $2 = _parse$$HEX_NUMBER(399, $1);
      if (_success) {
        break;
      } else {
        _c = $4;
        _pos = $5;
      }
      final $15 = _predicate;
      final $16 = $1;
      _predicate = true;
      $1 = false;
      if (_success = _c == 92) {
        _c = _input[++_pos];
      } else {
        _failure = _pos;
      }
      _c = $4;
      _pos = $5;
      _predicate = $15;
      $1 = $16;
      _success = !_success;
      if (_success) {
        final $19 = _c;
        final $20 = _pos;
        final $21 = _predicate;
        final $22 = $1;
        _predicate = true;
        $1 = false;
        _parse$$EOL(404, false);
        _c = $19;
        _pos = $20;
        _predicate = $21;
        $1 = $22;
        _success = !_success;
        if (_success) {
          if (_success = _c < _eof) {
            $2 = _c;
            _c = _input[_pos += _c <= 65535 ? 1 : 2];
          } else {
            _failure = _pos;
          }
        }
      }
      if (_success) {
      } else {
        _c = $4;
        _pos = $5;
      }
      break;
    }
    return $2;
  }

  List<int> _parse$$RANGE(int $0, bool $1) {
    List<int> $2;
    final $4 = _c;
    final $5 = _pos;
    for (;;) {
      final $8 = _parse$$RANGE_CHAR(408, $1);
      if (_success) {
        if (_success = _c == 45) {
          _c = _input[++_pos];
        } else {
          _failure = _pos;
        }
        if (_success) {
          final $10 = _parse$$RANGE_CHAR(410, $1);
          if (_success) {
            final s = $8;
            final e = $10;
            List<int> $$;
            $$ = [s, e];
            $2 = $$;
          }
        }
      }
      if (_success) {
        break;
      } else {
        _c = $4;
        _pos = $5;
      }
      final $13 = _parse$$RANGE_CHAR(412, $1);
      if (_success) {
        final c = $13;
        List<int> $$;
        $$ = [c, c];
        $2 = $$;
      }
      if (_success) {
      } else {
        _c = $4;
        _pos = $5;
      }
      break;
    }
    return $2;
  }

  int _parse$$RANGE_CHAR(int $0, bool $1) {
    int $2;
    final $4 = _c;
    final $5 = _pos;
    for (;;) {
      if (_success = _c == 92) {
        _c = _input[++_pos];
      } else {
        _failure = _pos;
      }
      if (_success) {
        int $9;
        if (_success =
            _c >= 92 && _c <= 93 || _c == 110 || _c == 114 || _c == 116) {
          $9 = _c;
          _c = _input[++_pos];
        } else {
          _failure = _pos;
        }
        if (_success) {
          final c = $9;
          int $$;
          $$ = _escape(c);
          $2 = $$;
        }
      }
      if (_success) {
        break;
      } else {
        _c = $4;
        _pos = $5;
      }
      $2 = _parse$$HEX_NUMBER(418, $1);
      if (_success) {
        break;
      } else {
        _c = $4;
        _pos = $5;
      }
      final $15 = _predicate;
      final $16 = $1;
      _predicate = true;
      $1 = false;
      if (_success = _c >= 92 && _c <= 93) {
        _c = _input[++_pos];
      } else {
        _failure = _pos;
      }
      _c = $4;
      _pos = $5;
      _predicate = $15;
      $1 = $16;
      _success = !_success;
      if (_success) {
        final $19 = _c;
        final $20 = _pos;
        final $21 = _predicate;
        final $22 = $1;
        _predicate = true;
        $1 = false;
        _parse$$EOL(423, false);
        _c = $19;
        _pos = $20;
        _predicate = $21;
        $1 = $22;
        _success = !_success;
        if (_success) {
          if (_success = _c < _eof) {
            $2 = _c;
            _c = _input[_pos += _c <= 65535 ? 1 : 2];
          } else {
            _failure = _pos;
          }
        }
      }
      if (_success) {
      } else {
        _c = $4;
        _pos = $5;
      }
      break;
    }
    return $2;
  }

  dynamic _parse$$SPACE(int $0, bool $1) {
    dynamic $2;
    final $4 = _c;
    final $5 = _pos;
    for (;;) {
      if (_success = _c == 9 || _c == 32) {
        $2 = _c;
        _c = _input[++_pos];
      } else {
        _failure = _pos;
      }
      if (_success) {
        break;
      } else {
        _c = $4;
        _pos = $5;
      }
      $2 = _parse$$EOL(429, false);
      if (_success) {
      } else {
        _c = $4;
        _pos = $5;
      }
      break;
    }
    return $2;
  }

  List _parse$$SPACING(int $0, bool $1) {
    List $2;
    final $4 = _c;
    final $5 = _pos;
    for (;;) {
      final $10 = _c;
      final $11 = _pos;
      for (;;) {
        _parse$$SPACE(435, false);
        if (_success) {
          break;
        } else {
          _c = $10;
          _pos = $11;
        }
        _parse$$COMMENT(437, false);
        if (_success) {
        } else {
          _c = $10;
          _pos = $11;
        }
        break;
      }
      if (!_success) {
        break;
      }
    }
    _success = true;
    if (!_success) {
      _c = $4;
      _pos = $5;
    }
    return $2;
  }

  int _parse$$TERMINAL_CHAR(int $0, bool $1) {
    int $2;
    final $4 = _c;
    final $5 = _pos;
    for (;;) {
      if (_success = _c == 47) {
        _matchString('//');
      } else {
        _failure = _pos;
      }
      if (_success) {
        if (_success = _c == 39) {
          $2 = _c;
          _c = _input[++_pos];
        } else {
          _failure = _pos;
        }
      }
      if (_success) {
        break;
      } else {
        _c = $4;
        _pos = $5;
      }
      if (_success = _c >= 32 && _c <= 38 || _c >= 40 && _c <= 126) {
        $2 = _c;
        _c = _input[++_pos];
      } else {
        _failure = _pos;
      }
      if (_success) {
      } else {
        _c = $4;
        _pos = $5;
      }
      break;
    }
    return $2;
  }
}

class _Memo {
  final int id;

  final int pos;

  final result;

  final bool success;

  _Memo({
    this.id,
    this.pos,
    this.result,
    this.success,
  });
}

// ignore_for_file: unused_element
// ignore_for_file: unused_field
